From 9b2f1a99bd8a411926925ac0c91f50289c7db8ee Mon Sep 17 00:00:00 2001
From: Thomas Holder <thomas@thomas-holder.de>
Date: Sat, 16 Nov 2019 14:12:24 +0100
Subject: [PATCH] fix poppler 0.82.0 build
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Backport of 324c7903d9fd62e74c042c31477299be3b980fd2 from master by
Andreas K. Hüttel <dilfridge@gentoo.org>
---
 src/extension/internal/pdfinput/pdf-parser.cpp           | 2 +-
 src/extension/internal/pdfinput/poppler-transition-api.h | 6 ++++++
 src/extension/internal/pdfinput/svg-builder.cpp          | 2 +-
 src/extension/internal/pdfinput/svg-builder.h            | 2 +-
 4 files changed, 9 insertions(+), 3 deletions(-)

diff --git a/src/extension/internal/pdfinput/pdf-parser.cpp b/src/extension/internal/pdfinput/pdf-parser.cpp
index ddbff7671f..e71bb79381 100644
--- a/src/extension/internal/pdfinput/pdf-parser.cpp
+++ b/src/extension/internal/pdfinput/pdf-parser.cpp
@@ -2414,7 +2414,7 @@ void PdfParser::doShowText(GooString *s) {
   int wMode;
   double riseX, riseY;
   CharCode code;
-  Unicode *u = NULL;
+  Unicode _POPPLER_CONST_82 *u = NULL;
   double x, y, dx, dy, tdx, tdy;
   double originX, originY, tOriginX, tOriginY;
   double oldCTM[6], newCTM[6];
diff --git a/src/extension/internal/pdfinput/poppler-transition-api.h b/src/extension/internal/pdfinput/poppler-transition-api.h
index 21a60702fa..93c0f99ba1 100644
--- a/src/extension/internal/pdfinput/poppler-transition-api.h
+++ b/src/extension/internal/pdfinput/poppler-transition-api.h
@@ -3,6 +3,12 @@
 
 #include <glib/poppler-features.h>
 
+#if POPPLER_CHECK_VERSION(0, 82, 0)
+#define _POPPLER_CONST_82 const
+#else
+#define _POPPLER_CONST_82
+#endif
+
 #if POPPLER_CHECK_VERSION(0, 76, 0)
 #define _POPPLER_NEW_PARSER(xref, obj) Parser(xref, obj, gFalse)
 #else
diff --git a/src/extension/internal/pdfinput/svg-builder.cpp b/src/extension/internal/pdfinput/svg-builder.cpp
index 1cefb92abd..ea2940ffe1 100644
--- a/src/extension/internal/pdfinput/svg-builder.cpp
+++ b/src/extension/internal/pdfinput/svg-builder.cpp
@@ -1379,7 +1379,7 @@ void SvgBuilder::beginString(GfxState *state) {
 void SvgBuilder::addChar(GfxState *state, double x, double y,
                          double dx, double dy,
                          double originX, double originY,
-                         CharCode /*code*/, int /*nBytes*/, Unicode *u, int uLen) {
+                         CharCode /*code*/, int /*nBytes*/, Unicode const *u, int uLen) {
 
 
     bool is_space = ( uLen == 1 && u[0] == 32 );
diff --git a/src/extension/internal/pdfinput/svg-builder.h b/src/extension/internal/pdfinput/svg-builder.h
index 34b42e17b8..78e302081f 100644
--- a/src/extension/internal/pdfinput/svg-builder.h
+++ b/src/extension/internal/pdfinput/svg-builder.h
@@ -141,7 +141,7 @@ public:
     void addChar(GfxState *state, double x, double y,
                  double dx, double dy,
                  double originX, double originY,
-                 CharCode code, int nBytes, Unicode *u, int uLen);
+                 CharCode code, int nBytes, Unicode const *u, int uLen);
     void beginTextObject(GfxState *state);
     void endTextObject(GfxState *state);
 
-- 
2.24.0

